<?php  
// TO DO: remove deprecated custom post   =Custom Post 

global $childishlysimple_backend_details; 

/*
=Post formats
*/

add_action( 'after_setup_theme', 'childishlysimple_add_post_formats' ); // after_switch_theme might be better

if ( !function_exists( 'childishlysimple_add_post_formats' ) ) {
	function childishlysimple_add_post_formats( ) {
		add_theme_support( 'post-formats', array( 'aside', 'chat', 'gallery', 'image', 'link', 'quote', 'status', 'video', 'audio' ) ); 
}
}





/*
=Automatic feed links (in the <head></head> section of the web page)
*/

add_theme_support('automatic-feed-links');






/*
 =Featured images 
*/

add_theme_support( 'post-thumbnails' );







/*
=Custom background
http://codex.wordpress.org/Function_Reference/add_theme_support
*/

$selected_color_scheme_again = get_option ( 'childishlysimple01_selected_color_scheme' );
$allow_custom_background_array = array();
$allow_custom_background_array = get_option( 'childishlysimple01_allow_custom_background' );

if ( $selected_color_scheme_again == 'change_this_color_scheme' ) {

	if ($allow_custom_background_array !== '') {
		if( in_array( 'allow_custom_background', $allow_custom_background_array ) )  add_theme_support( 'custom-background' );
}
}



	 




/*
=Custom header - Appearance / header -  see header.php for outputting.
*/

//	http://codex.wordpress.org/Custom_Headers
//	http://codex.wordpress.org/Function_Reference/add_theme_support#Custom_Header

$defaults = array( 
	'default-image' => get_template_directory_uri() . '/images/header.jpg',
	'random-default'         => false,
	'width'                  => 1000, // Suggested height e.g. suggested cropped area when first uploaded
	'height'                 => 300, // Suggested height e.g. suggested cropped area when first uploaded
	'flex-height'            => true, // If set to false the cropped area won't exceed the height set above
	'flex-width'             => true, // If set to false the cropped area won't exceed the width set above
	'default-text-color'     => '',
	'header-text'            => false, // No idea how to output it anyway.
	'uploads'                => true,
	'wp-head-callback'       => '',
	'admin-head-callback'    => '',
	'admin-preview-callback' => '',
);
add_theme_support( 'custom-header', $defaults );







/*
=Woocommerce
*/
add_theme_support( 'woocommerce' );







/* 
=Style editor
	
Thanks to: http://www.deluxeblogtips.com/2010/05/editor-style-wordpress-30.html
See also:	http://codex.wordpress.org/Function_Reference/add_editor_style
See    style-tinymce.css    for more information.
*/

add_editor_style('style-tinymce.css'); 






/*
=Excerpt length	Change the number of words shown in the default excerpt (but NOT when you manually enter an excerpt into the excerpt box beneath a post). 
*/

add_filter( 'excerpt_length', 'childishlysimple_new_excerpt_length' );

if ( !function_exists( 'childishlysimple_new_excerpt_length' ) ) {
	function childishlysimple_new_excerpt_length( $length ) {
		return 55;
}
}







/*
=Untitled  Add 'Untitled' to untitled posts
*/
add_filter('the_title', 'childishlysimple_title');

if ( !function_exists( 'childishlysimple_title' ) ) {
	function childishlysimple_title($title) {
		if ($title == '') {
			return 'Untitled';
		} else {
			return $title;
			}
}
}







/*
=Body class filter
*/

add_filter('body_class','my_class_names');

if ( !function_exists( 'my_class_names' ) ) {
	function my_class_names($classes) {
		$childishlysimple_backend_details = array();
		$childishlysimple_backend_details = get_option( 'childishlysimple01_registered_layout_details' ); 
		$layout = $childishlysimple_backend_details['site_layout'] ;
		$classes[] = $layout;
		return $classes;
}
}







/*
=Title Filter	 Filter the title tag in the header of each page
*/

if ( !function_exists( 'childishlysimple_filter_wp_title' ) ) {
function childishlysimple_filter_wp_title( $title, $sep, $sep_location  ) {

    $site_name = get_bloginfo( 'name' );
    $filtered_title =  $title . $site_name ;
    return $filtered_title;
}
}

add_filter( 'wp_title', 'childishlysimple_filter_wp_title', 10, 3 );
//	Thanks to http://wikiduh.com/1102/using-the-wp_title-filter-in-wordpress
//	http://wordpress.stackexchange.com/questions/32622/when-calling-wp-title-do-you-have-to-create-some-kind-of-title-php-file







/*
=Remove 10px that WP adds to the divs around captioned images.  Thanks to:  Justin Tadlock  http://devpress.com/blog/captions-in-wordpress/
*/

add_filter( 'img_caption_shortcode', 'childishlysimple_cleaner_caption', 10, 3 );

if ( !function_exists( 'childishlysimple_cleaner_caption' ) ) {
function childishlysimple_cleaner_caption( $output, $attr, $content ) {

if ( is_feed() ) return $output;
//	We're not worried abut captions in feeds, so just return the output here. 

	$defaults = array(
		'id' => '',
		'align' => 'alignnone',
		'width' => '',
		'caption' => ''
				);
	//	Set up the default arguments.
	
	$attr = shortcode_atts( $defaults, $attr );
	//	Merge the defaults with user input. 


	if ( 1 > $attr['width'] || empty( $attr['caption'] ) ) return $content;
	//	If the width is less than 1 or there is no caption, return the content wrapped between the [caption]< tags. 
		

	$attributes = ( !empty( $attr['id'] ) ? ' id="' . esc_attr( $attr['id'] ) . '"' : '' );
	$attributes .= ' class="wp-caption ' . esc_attr( $attr['align'] ) . '"';
	$attributes .= ' style="width: ' . esc_attr( $attr['width'] ) . 'px"';
	//	Set up the attributes for the caption <div>. 

	
	$output = '<div' . $attributes .'>';
	//	Open the caption <div>.


	$output .= do_shortcode( $content );
	//	Allow shortcode for the content the caption was created for. 

	
	$output .= '<p class="wp-caption-text">' . $attr['caption'] . '</p>';
	//	Append the caption text. 

	
	$output .= '</div>';
	//	Close the caption </div>. 

	
	return $output;
	//	Return the formatted, clean caption. 
	
}	//	End function childishlysimple_cleaner_caption
}







/*
=Change text [...] after the default excerpt
*/

add_filter( 'excerpt_more', 'childishlysimple_new_excerpt_more' );

if ( !function_exists( 'childishlysimple_new_excerpt_more' ) ) {
function childishlysimple_new_excerpt_more( $post ) {
		global $post;
		return '<span class="more-excerpt"><a class="more-excerpt-link" href="'. get_permalink( $post->ID ) . '">' . ' (continue reading...)  ' . '</a></span>';
}
}







/*
=Admin screen defaults. Overcomes 3.1 problem of not showing custom fields by default.
Thanks to: billerickson   http://wordpress.org/support/topic/extra-fields-dissapeared-in-new-post?replies=7
				     http://ottopress.com/2011/wp-quickie-metaboxes/
*/

add_filter( 'default_hidden_meta_items', 'childishlysimple_be_hidden_meta_items', 10, 2 );

if ( !function_exists( 'childishlysimple_be_hidden_meta_items' ) ) {
	function childishlysimple_be_hidden_meta_items( $hidden, $screen ) {
		if ( 'post' == $screen->base || 'page' == $screen->base )
		$hidden = array( 'slugdiv', 'trackbacksdiv', 'postexcerpt', 'commentstatusdiv', 'commentsdiv', 'authordiv', 'revisionsdiv' ); // removed 'postcustom',
		return $hidden;
}
}







/*
=Default gravatar. With thanks to: http://www.wpbeginner.com/wp-tutorials/how-to-change-the-default-gravatar-on-wordpress/ 
*/

add_filter( 'avatar_defaults', 'childishlysimple_newgravatar' );

if ( !function_exists( 'childishlysimple_newgravatar' ) ) {
	function childishlysimple_newgravatar( $avatar_defaults ) {
  		$myavatar =  get_template_directory_uri()  . '/images/gravatar1.gif';
    		$avatar_defaults[$myavatar] = "Another Avatar"; // The name that appears in Admin / Settings / Discussion, where you select a default avatar
    		return $avatar_defaults;
}
}







/*
=Browser detection. Used to add a class to the body div.	With thanks to: http://www.nathanrice.net/blog/browser-detection-and-the-body_class-function/
*/

add_filter('body_class','childishlysimple_browser_body_class');

if ( !function_exists( 'childishlysimple_browser_body_class' ) ) {
	function childishlysimple_browser_body_class($classes) {
		global $is_lynx, $is_gecko, $is_IE, $is_opera, $is_NS4, $is_safari, $is_chrome, $is_iphone;

		if($is_lynx) $classes[] = 'lynx';
		elseif($is_gecko) $classes[] = 'gecko';
		elseif($is_opera) $classes[] = 'opera';
		elseif($is_NS4) $classes[] = 'ns4';
		elseif($is_safari) $classes[] = 'safari';
		elseif($is_chrome) $classes[] = 'chrome';
		elseif($is_IE) $classes[] = 'ie';
		else $classes[] = 'unknown';

		if($is_iphone) $classes[] = 'iphone';
		return $classes;
}
}







/*
=Paragraph elements around images on landing page
Thanks to:  	http://css-tricks.com/snippets/wordpress/remove-paragraph-tags-from-around-images/
http://wordpress.stackexchange.com/questions/28207/add-filter-for-specific-pages
*/


if ( !function_exists( 'filter_ptags_on_images' ) ) {

	function filter_ptags_on_images($content){

		if (is_page_template( 'page-landing-page.php' ) ) {
  			 return preg_replace('/<p>\s*(<a .*>)?\s*(<img .* \/>)\s*(<\/a>)?\s*<\/p>/iU', '\1\2\3', $content);
		} else {
			return $content; 
			}
	}
}
add_filter('the_content', 'filter_ptags_on_images');







/**
 * Create HTML list of nav menu items.
 * Replacement for the native Walker, using the description.
 *
 * @see    http://wordpress.stackexchange.com/q/14037/
 * @author toscho, http://toscho.de
 */
class Description_Walker extends Walker_Nav_Menu
{
    /**
     * Start the element output.
     *
     * @param  string $output Passed by reference. Used to append additional content.
     * @param  object $item   Menu item data object.
     * @param  int $depth     Depth of menu item. May be used for padding.
     * @param  array $args    Additional strings.
     * @return void
     */
    function start_el( &$output, $item, $depth = 0, $args = array(), $id = 0 )
    {
        $classes     = empty ( $item->classes ) ? array () : (array) $item->classes;

        $class_names = join(
            ' '
        ,   apply_filters(
                'nav_menu_css_class'
            ,   array_filter( $classes ), $item
            )
        );

        ! empty ( $class_names )
            and $class_names = ' class="'. esc_attr( $class_names ) . '"';

        $output .= "<li id='menu-item-$item->ID' $class_names>";

        $attributes  = '';

        ! empty( $item->attr_title )
            and $attributes .= ' title="'  . esc_attr( $item->attr_title ) .'"';
        ! empty( $item->target )
            and $attributes .= ' target="' . esc_attr( $item->target     ) .'"';
        ! empty( $item->xfn )
            and $attributes .= ' rel="'    . esc_attr( $item->xfn        ) .'"';
        ! empty( $item->url )
            and $attributes .= ' href="'   . esc_attr( $item->url        ) .'"';

        // insert description for top level elements only
        // you may change this
        $description = ( ! empty ( $item->description ) and 0 == $depth )
            ? '<small class="nav_desc">' . esc_attr( $item->description ) . '</small>' : '';

        $title = apply_filters( 'the_title', $item->title, $item->ID );

        $item_output = $args->before
            . "<a $attributes>"
            . $args->link_before
            . $title
            . '</a> '
            . $args->link_after
            . $description
            . $args->after;

        // Since $output is called by reference we don't need to return anything.
        $output .= apply_filters(
            'walker_nav_menu_start_el'
        ,   $item_output
        ,   $item
        ,   $depth
        ,   $args
        );
    }
}







/*
=Custom Post Type homepage - DEPRECATED. This will be replaced with a simpler method. 
*/

add_action( 'init', 'childishlysimple_add_home_page' );

if ( !function_exists( 'childishlysimple_add_home_page' ) ) {
	function childishlysimple_add_home_page( ) { 
	
	$show_custom_post_homepage = '';
	 
	$get_home_page = get_option( 'childishlysimple01_selected_home_page' );
	/*
		if ( ($get_home_page == 'custom_post') || ($get_home_page == 'custom_post_with_widgets') ) { // Show the custom post type 'Very Simple Home Page'
			$show_custom_post_homepage = true; 
				} else {
					$show_custom_post_homepage = false; 
				 	 }
	*/
			

	$labels = array(      
		'name' => 'Very Simple Home Page', 	
		'all_items'  => 'All home pages', 	
		'singular_name' => 'Create a simple home page', 
		'add_new' => 'Add a new home page', 
		'add_new_item' => 'Add a new home page',
		'edit' => 'Edit home pages',   	
		'edit_item' => 'Edit home pages',   	   
		'new_item' => 'New home page', 		    
		'view' => 'You can only view this post on the home page',  
		'view_item' => 'You can only view this post on the home page', 
		'search_items' => 'Search home pages', 
		'not_found' => 'No home pages found',  
		'not_found_in_trash' => 'No home pages found in trash',
		'parent' => 'Parent home page',    
);


	$settings = array( 
		'labels' => $labels,
		'show_ui' => true, 	
		'show_in_menu' => false,	
		'public' => true,
		'show_in_nav_menus' => false,
		'publicly_queryable' => true, 	
		'exclude_from_search' => true, 
		'description' => 'Brilliant Home Pages ',  
		'menu_position' => 80, 	
		'menu_icon' => 	get_template_directory_uri( ) . '/images/admin-custom-home.gif', 	
		'hierarchical' => false, 	
		'query_var' => true, 				// Can this post type be used with query_posts before the loop?		
		'capability_type' => 'post',	// Vital for 'Add new post' etc.
		
		'capabilities' => array(
   		'edit_post'          => 'edit_cst_home_page',
  		'read_post'          => 'read_cst_home_page',
  		'delete_post'        => 'delete_cst_home_page',
 		'edit_posts'         => 'edit_cst_home_pages',
   		'edit_others_posts'  => 'edit_others_cst_home_pages',
   		'publish_posts'      => 'publish_cst_home_pages',
    		'read_private_posts' => 'read_private_cst_home_pages'  
), 
		
		'map_meta_cap' => true,
		'show_in_admin_bar' => true,
		'has_archive' => false,  // Hopefully this won't show up in any archives
		'supports' => array( 'title', 'editor', 'comments','trackbacks', 'revisions','author', 'excerpt',  'thumbnail','custom-fields', 'page-attributes' ), 
		'_builtin' => false,	// See:  http://kovshenin.com/archives/extending-custom-post-types-in-wordpress-3-0/
		'rewrite' => false, 
		// 'taxonomies' => array( 'book_category', 'other_books' ),             
		'can_export' => true,	//	Whether or not this particular post type can be exported / backed up to XML
		'permalink_epmask' => EP_PERMALINK,	//	Permalink endpoint mask, whatever that is. Now replaced by 'ep_mask' in rewrite

	 );

	register_post_type( 'cst_home_page', $settings ); // character limit of 20

} 	//	End function childishlysimple_add_home_page
}







if ( !function_exists( 'childishlysimple_add_new_capabilities' ) ) {
function childishlysimple_add_new_capabilities( ) {

	$AdaptRole2 = get_role( 'administrator' ); 	// Only the administrator is going to see / edit etc. the home pages
	$AdaptRole2 -> add_cap( 'edit_cst_home_page' ); 
	$AdaptRole2 -> add_cap( 'read_cst_home_page' );  
	$AdaptRole2 -> add_cap( 'delete_cst_home_page' );  
	$AdaptRole2 -> add_cap( 'edit_cst_home_pages' );  
	$AdaptRole2 -> add_cap( 'edit_others_cst_home_pages' ); 
	$AdaptRole2 -> add_cap( 'publish_cst_home_pages' ); 
	$AdaptRole2 -> add_cap( 'read_private_cst_home_pages' );  
	
} //	End  function childishlysimple_add_new_capabilities()
}

add_action( 'init', 'childishlysimple_add_new_capabilities' ); 
//	END DEPRECATED







/*
=Custom menus
*/

add_action( 'init', 'childishlysimple_register_my_menus' );

if ( !function_exists( 'childishlysimple_register_my_menus' ) ) {
	function childishlysimple_register_my_menus( ) {
		register_nav_menus( 
				array( 
					'menu-1' =>  'Top Menu (Childishly Simple Theme)' , 
					'menu-2' => 'Bottom Menu (Childishly Simple Theme)',
					//'menu-3' =>  'Menu Somewhere Else',
					//'menu-4' => 'Menu Some Place Else' ,
					 )
			 );
} //	End  function childishlysimple_register_my_menus( )
}
//	 menu-1 ( or any other text ) is used internally by WP.  Top Menu is the user-friendly name displayed in the Admin Panel
//	This registers some menu boxes in the Admin Panel. You then have to drag and drop links into these boxes from within the Admin Panel.
//	The menu is displayed on an appropriate template file by adding some code to that file e.g.   'theme_location' => 'menu-1' etc.   which would be  code to display    menu-1 







/*
=Childishly Simple theme options
*/



add_action( 'admin_menu', 'childishlysimple_options_layout_menu' );	
//	Comment out the above line to remove the Childishly Simple Options page completely from the Admin screen.
//	Any options that have already been saved will still exist in the database.



if ( !function_exists( 'childishlysimple_options_layout_menu' ) ) {
	function childishlysimple_options_layout_menu( ) {
		global $childishlysimple_add_my_options;
		//	Add a submenu item to the Appearance menu  http://codex.wordpress.org/Function_Reference/add_theme_page 
	
		$childishlysimple_options_style ='';
	
		$childishlysimple_options_style = '<span class="childishlysimple-options-submenu" style="background:transparent url(' . get_template_directory_uri() . '/images/admin-options.gif) top left no-repeat; padding:0 0 0 20px;">Childishly Simple Options</span>';
	
	
		$childishlysimple_add_my_options = add_theme_page( 'Childishly Simple Options', $childishlysimple_options_style , 'edit_theme_options', 'childishlysimple_options','childishlysimple_function_to_create_layout');


		//	=Add scripts just to the options page
		add_action( 'admin_enqueue_scripts', 'childishlysimple_admin_layout_enqueue_scripts' );

		//	Set up the various options using register_setting
		add_action( 'admin_init', 'childishlysimple_set_up_my_layout' ); 
	
} // end function childishlysimple_options_layout_menu
}







if ( !function_exists( 'childishlysimple_admin_layout_enqueue_scripts' ) ) {
	function childishlysimple_admin_layout_enqueue_scripts( $hook_suffix) {
		global 	$childishlysimple_add_my_options;
	
		if ( $childishlysimple_add_my_options == $hook_suffix ) {
	
			wp_register_style( 'style-options.css', get_template_directory_uri() . '/style-options.css', '', '', 'screen' );
			wp_enqueue_style( 'style-options.css' );

			wp_register_style( 'style-options-premium.css', get_template_directory_uri() . '/style-options-premium.css', '', '', 'screen' );
			wp_enqueue_style( 'style-options-premium.css' );
		
			wp_enqueue_script( 'jquery-ui-accordion');
		
			wp_register_script( 'accordion-js', get_template_directory_uri() . '/javascript/accordion.js' );
			wp_enqueue_script( 'accordion-js' );

			wp_register_script( 'anchor-js', get_template_directory_uri() . '/javascript/anchor.js' );
			wp_enqueue_script( 'anchor-js' );
		
			wp_register_style( 'style-accordion-css', get_template_directory_uri() . '/style-accordion.css');
			wp_enqueue_style( 'style-accordion-css' );
		
			wp_register_style( 'style-accordion-custom-css', get_template_directory_uri() . '/style-accordion-custom.css', array( 'style-accordion-css' ));
			wp_enqueue_style( 'style-accordion-custom-css' );
		
			wp_enqueue_style( 'wp-color-picker' );
			wp_enqueue_script( 'wp-color-picker' );
		 
			wp_register_script( 'wp-color-picker-js', get_template_directory_uri() . '/javascript/wpcolorpicker.js' );
			wp_enqueue_script( 'wp-color-picker-js' );

	}
} // end  function childishlysimple_admin_layout_enqueue_scripts
}







// Child theme can add extra register_settings for an updated options page
if ( !function_exists( 'childishlysimple_set_up_my_layout' ) ) {

function childishlysimple_set_up_my_layout( ) {

	//	Start the process of setting up options. Every option has to be named here first before it can be used in     function-to-create-layout.php
	//	By prefixing each option with childishlysimple01_   you can do a search and replace at any time and thus change all options at once for testing purposes
	//	NOTE: THERE IS A 64 CHARACTER LIMIT TO THE OPTION NAME 
	//	IF YOU EXCEED THE LIMIT YOUR OPTION WON'T BE REGISTERED AND ALL YOU'LL GET IS DEFAULTS.
	//	This can be very confusing if you've got option names close to the limit and are adding random characters to the beginning of the string during testing -
	//	some option names will go over the limit and some will stay under the limit.  Also it appears that option names must begin with a letter not a number.



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_liquid_or_fixed', 'childishlysimple_options_sanitisation' );  //	Liquid or fixed layout
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_site_width', 'childishlysimple_options_sanitisation' ); //	Site width
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_general_head_element');  //	General head element content
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_head_element');  //	Home page head element content
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_landing_page_head_element');  //	Landing page head element content
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_above_website');  //	HTML above website
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_above_top_banner_image');  //	HTML above banner image
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_replace_top_banner_image');  //	Replace banner image e.g. with a slideshow
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_heading_color');  //	Color of title / description deprecated early Feb 2014
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_primary_tagline_text');  // Primary tagline text
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_primary_tagline_link');  // Primary tagline link
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_primary_tagline_color');  // Primary tagline color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_secondary_tagline_text');  // Secondary tagline text
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_secondary_tagline_link');  //Secondary tagline link
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_secondary_tagline_color'); //  Secondary tagline color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_header_image_link');  //	Optional link for header image
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_below_top_banner_image');  //	HTML below banner image
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_below_top_navigation');  //	HTML below top navigation



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_selected_color_scheme'); // Select a color scheme


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_selected_home_page'); // Selected home page
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_textarea_border_width', 'childishlysimple_options_sanitisation' ); // textarea border width
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_sidebars'); // Home page sidebars
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_top_spacer'); // Home page top spacer
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_spacer'); // Home page bottom spacer
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_left_spacer'); // Home page left spacer
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_right_spacer'); // Home page right spacer
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_content_background_color', 'childishlysimple_options_sanitisation' ); //  home page content area background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_footer_background_color', 'childishlysimple_options_sanitisation' ); //  home page footer area background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_footer_widgets'); // Home page footer widgets?
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_footer_widgets_widget_spacer', 'childishlysimple_options_sanitisation'); // Home page footer spacer




	// Simple home page without widgets. DEPRECATED
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_no_widgets_page_background', 'childishlysimple_options_sanitisation'); 



	// Simple home page with widgets. START DEPRECATED
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_number_of_widgets', 'childishlysimple_options_sanitisation'); // Number of widgets
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_content_background', 'childishlysimple_options_sanitisation'); // Content background
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_w_area_background', 'childishlysimple_options_sanitisation'); // W area background
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_widget_spacer', 'childishlysimple_options_sanitisation'); // Widgets spacer
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_minimum_height', 'childishlysimple_options_sanitisation'); //  Widgets height
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_heading_background', 'childishlysimple_options_sanitisation'); //Heading background 
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_background_color', 'childishlysimple_options_sanitisation'); // Widget background 
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_border_color', 'childishlysimple_options_sanitisation'); // Widget border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_heading_font_color'); //  Widget heading font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_font_color', 'childishlysimple_options_sanitisation'); //  Widget text color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_link_color', 'childishlysimple_options_sanitisation'); //  Link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_custom_with_widgets_hover_color', 'childishlysimple_options_sanitisation'); //  Hover color
	// END DEPRECATED



	

// Note to me: remove deprecated hidden fields from function-to-create-layout.php

// When register_setting runs it overwrites options with 'nothing' unless that option is being specifically / currently saved using a form element
// This means that home pages that are incorporated with get_template_part which are not CURRENTLY incorporated will have their options overwritten with 'nothing' 
// One way round this is to fetch the value using get_option and then save that value using a hidden field in function-to-create-layout.php directly above the included home page
// This isn't a good solution when there are multiple home pages each with multiple text areas containing HTML
// A better way (below) for largish amounts of data is to enable specific register_settings dependant on which home page is being included







$selected_home_page = 'childishlysimple01_selected_home_page';	
$selected_home_page_dropdown = get_option( "$selected_home_page" );  

if ( $selected_home_page_dropdown == 'multiple_posts' ) {
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_index_heading', 'childishlysimple_options_sanitisation' ); //  home page heading
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_heading_color', 'childishlysimple_options_sanitisation' ); //  home page heading color
}







if ( $selected_home_page_dropdown == 'simple_home_01' ) {
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_01_textarea_01_content' ); // Text area 01 DO NOT SANITISE
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_01_textarea_01_background_color', 'childishlysimple_options_sanitisation' ); // textarea 01 background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_01_textarea_01_border_color', 'childishlysimple_options_sanitisation' ); // textarea 01 border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_01_textarea_01_height', 'childishlysimple_options_sanitisation' ); // textarea 01 height
}







 if ( $selected_home_page_dropdown == 'simple_home_02' ) {

	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_01_content' ); // Text area 02 DO NOT SANITISE
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_01_background_color', 'childishlysimple_options_sanitisation' ); // textarea 01 background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_01_border_color', 'childishlysimple_options_sanitisation' ); // textarea 01 border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_01_height', 'childishlysimple_options_sanitisation' ); // textarea 01 border width


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_02_content' ); // Text area 02 DO NOT SANITISE
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_02_background_color', 'childishlysimple_options_sanitisation' ); // textarea 01 background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_02_border_color', 'childishlysimple_options_sanitisation' ); // textarea 01 border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_02_border_width', 'childishlysimple_options_sanitisation' ); // textarea 01 border width deprecated
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_02_height', 'childishlysimple_options_sanitisation' ); // textarea 01 border width


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_03_content' ); // Text area 03 DO NOT SANITISE
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_03_background_color', 'childishlysimple_options_sanitisation' ); // textarea 01 background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_03_border_color', 'childishlysimple_options_sanitisation' ); // textarea 01 border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_03_border_width', 'childishlysimple_options_sanitisation' ); // textarea 01 border width deprecated
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_03_height', 'childishlysimple_options_sanitisation' ); // textarea 01 border width


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_04_content' ); // Text area 04 DO NOT SANITISE
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_04_background_color', 'childishlysimple_options_sanitisation' ); // textarea 01 background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_04_border_color', 'childishlysimple_options_sanitisation' ); // textarea 01 border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_04_border_width', 'childishlysimple_options_sanitisation' ); // textarea 01 border width deprecated
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_04_height', 'childishlysimple_options_sanitisation' ); // textarea 01 border width


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_05_content' ); // Text area 05 DO NOT SANITISE
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_05_background_color', 'childishlysimple_options_sanitisation' ); // textarea 01 background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_05_border_color', 'childishlysimple_options_sanitisation' ); // textarea 01 border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_05_border_width', 'childishlysimple_options_sanitisation' ); // textarea 01 border width deprecated
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_simple_02_textarea_05_height', 'childishlysimple_options_sanitisation' ); // textarea 01 border width
}







	// Home page bottom widgets
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_widget_spacer', 'childishlysimple_options_sanitisation'); // Widgets spacer
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_minimum_height', 'childishlysimple_options_sanitisation'); //  Widgets height
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_number_of_widgets', 'childishlysimple_options_sanitisation'); // Number of widgets
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_left_space', 'childishlysimple_options_sanitisation'); // Widget area left space
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_right_space', 'childishlysimple_options_sanitisation'); // Widget area right space
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_heading_background', 'childishlysimple_options_sanitisation'); // Heading background
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_background_color', 'childishlysimple_options_sanitisation'); // Individual widget background
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_list_underline', 'childishlysimple_options_sanitisation'); // List underline color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_border_color', 'childishlysimple_options_sanitisation'); // Widget border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_heading_font_color'); //  Widget heading font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_font_color', 'childishlysimple_options_sanitisation'); //  Widget text color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_link_color', 'childishlysimple_options_sanitisation'); //  Link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_hover_color', 'childishlysimple_options_sanitisation'); //  Hover color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_home_page_bottom_widgets_w_area_background', 'childishlysimple_options_sanitisation'); // Widget area background

	
	


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_beginner_or_advanced'); // user skill level

	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_sitewide_layout');  //	The site layout e.g. one-column
	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_body_background_color', 'childishlysimple_options_sanitisation'); //	Body background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_allow_custom_background'); //	Allow custom background ?
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_site_border_color', 'childishlysimple_options_sanitisation' ); //	Border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_site_border_width', 'childishlysimple_options_sanitisation' ); //	Border width
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_content_background_color', 'childishlysimple_options_sanitisation' ); //	Content background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_content_top_spacing', 'childishlysimple_options_sanitisation' ); //	Move content up or down
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_of_website_spacing', 'childishlysimple_options_sanitisation' ); //	Move website up or down
	


	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar', 'childishlysimple_options_sanitisation' ); //	Left sidebar width
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar', 'childishlysimple_options_sanitisation' ); //	Right sidebar width
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_sidebar_top_spacing', 'childishlysimple_options_sanitisation' ); //	Sidebar top spacing



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_items_selected' ); //	Selected left-sidebar items
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_items_selected' ); //	Selected right-sidebar items



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_item_background_color', 'childishlysimple_options_sanitisation' ); //	Left sidebar item background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_item_list_underline_color', 'childishlysimple_options_sanitisation' ); //	Left sidebar item list border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_item_border_color', 'childishlysimple_options_sanitisation' ); //	Left sidebar item border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_item_heading_background_color', 'childishlysimple_options_sanitisation' ); //  Left sidebar item heading background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_item_heading_font_color', 'childishlysimple_options_sanitisation' ); //	Left sidebar item heading font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_font_color', 'childishlysimple_options_sanitisation' );  //	Left sidebar font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_link_color', 'childishlysimple_options_sanitisation' );  //	Left sidebar link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_left_sidebar_hover_color', 'childishlysimple_options_sanitisation' );  //	Left sidebar hover color



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_item_background_color', 'childishlysimple_options_sanitisation' ); //	Right sidebar item background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_item_list_underline_color', 'childishlysimple_options_sanitisation' ); //	Right sidebar item list border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_item_border_color', 'childishlysimple_options_sanitisation' ); //	Right sidebar item border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_item_heading_background_color', 'childishlysimple_options_sanitisation' ); //	Right sidebar item heading background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_item_heading_font_color', 'childishlysimple_options_sanitisation' ); //	Right sidebar item heading font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_font_color', 'childishlysimple_options_sanitisation' );  //	Right sidebar font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_link_color', 'childishlysimple_options_sanitisation');  //	Right sidebar link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_right_sidebar_hover_color', 'childishlysimple_options_sanitisation');  //	Right sidebar hover color



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_short_left_sidebar_background_color', 'childishlysimple_options_sanitisation' ); // Short left sidebar background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_short_right_sidebar_background_color', 'childishlysimple_options_sanitisation' ); // Short right sidebar background color



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_long_left_sidebar_background_color', 'childishlysimple_options_sanitisation' ); // Long left sidebar background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_long_right_sidebar_background_color', 'childishlysimple_options_sanitisation' ); // Long right sidebar background color



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_items_selected' ); //	Selected footer items
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_item_minimum_height', 'childishlysimple_options_sanitisation' ); //	Minimum height of footer items
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_number_of_footer_items', 'childishlysimple_options_sanitisation'); //	Number of footer items
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_item_background_color', 'childishlysimple_options_sanitisation'); //	Footer item color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_item_list_underline_color', 'childishlysimple_options_sanitisation'); //Footer list border
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_item_border_color', 'childishlysimple_options_sanitisation' ); //	Footer item border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_item_heading_background_color', 'childishlysimple_options_sanitisation' ); //	Footer item heading background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_item_heading_font_color', 'childishlysimple_options_sanitisation' ); //	Footer item heading font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_font_color', 'childishlysimple_options_sanitisation' );  //	Footer  font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_link_color', 'childishlysimple_options_sanitisation' );  //	Footer  link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_hover_color', 'childishlysimple_options_sanitisation' );  //	Footer hover color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_background_color', 'childishlysimple_options_sanitisation' ); //	Footer background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_spacing', 'childishlysimple_options_sanitisation' ); //	Footer spacing
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_widgets_left_space', 'childishlysimple_options_sanitisation' ); // Left  space
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_footer_widgets_right_space', 'childishlysimple_options_sanitisation' ); // Right  space



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_utility_link_color', 'childishlysimple_options_sanitisation'); //	Utility links - link color (RSS, Powered by WordPress, Copyright)
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_utility_hover_color', 'childishlysimple_options_sanitisation' ); //	Utility links - hover color (RSS, Powered by WordPress, Copyright)



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_category_heading_font_color', 'childishlysimple_options_sanitisation' ); //	Category heading font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_post_title_font_color', 'childishlysimple_options_sanitisation' );  //	Post title font color - the title of each post
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_post_title_font_hover_color', 'childishlysimple_options_sanitisation' );  //	Post title font hover color - when hovered over
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_post_border_color', 'childishlysimple_options_sanitisation' ); //	Post and Page border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_post_margin_bottom', 'childishlysimple_options_sanitisation' ); //	Post margin bottom
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_post_background_color', 'childishlysimple_options_sanitisation' ); //	Post and Page background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_post_font_color', 'childishlysimple_options_sanitisation' );  //	Post and body font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_body_and_post_link_color', 'childishlysimple_options_sanitisation' );  //	Post and body link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_body_and_post_hover_color', 'childishlysimple_options_sanitisation' );  //	Post and body hover color



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_navigation_bar_background_color', 'childishlysimple_options_sanitisation' ); //	Top menu navigation bar background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_navigation_bar_top_border_color', 'childishlysimple_options_sanitisation' ); //	Top menu navigation bar top border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_navigation_bar_bottom_border_color', 'childishlysimple_options_sanitisation' ); //	Top menu navigation bar bottom border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_navigation_bar_link_color', 'childishlysimple_options_sanitisation' ); //	Top menu navigation bar link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_navigation_bar_hover_color', 'childishlysimple_options_sanitisation' ); //	Top menu navigation bar hover color



	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_dropdown_menu_background_color', 'childishlysimple_options_sanitisation' ); //	Top menu dropdown background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_dropdown_menu_hover_background_color', 'childishlysimple_options_sanitisation' ); //	Top menu dropdown hover background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_dropdown_menu_active_background_color', 'childishlysimple_options_sanitisation' ); //	Top menu dropdown active link background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_dropdown_menu_border_color', 'childishlysimple_options_sanitisation' ); //	Top menu dropdown border color	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_dropdown_menu_font_color', 'childishlysimple_options_sanitisation' ); //	Top menu dropdown font color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_top_dropdown_menu_hover_font_color', 'childishlysimple_options_sanitisation' ); //	Top menu dropdown hover font color	
	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_backlink' );  //	Backlink
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_miscellaneous_stuff' );  //	Miscellaneous items
	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_navigation_bar_background_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu navigation bar background color	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_navigation_bar_link_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu navigation bar link color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_navigation_bar_hover_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu navigation bar hover color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_navigation_bar_top_border_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu navigation bar top border color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_navigation_bar_bottom_border_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu navigation bar bottom border color	
	
	
	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_dropdown_menu_link_background_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu dropdown link background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_dropdown_menu_hover_background_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu dropdown hoverbackground color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_dropdown_menu_active_background_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu dropdown active link background color
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_dropdown_menu_border_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu dropdown border color	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_dropdown_menu_font_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu dropdown font color	
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_bottom_dropdown_menu_hover_font_color', 'childishlysimple_options_sanitisation' ); //	Bottom menu dropdown hover font color	


	// Bottom HTML
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_above_bottom_navigation_bar'); //	HTML at bottom of page above bottom navigation
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_below_bottom_navigation_bar'); //	HTML at bottom of page below bottom navigation
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_below_bottom_widgets'); //	HTML at bottom of page below footer widgets
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_at_bottom_of_website_inside_wrapper'); //	HTML at bottom of page inside wrapper
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_html_at_bottom_of_website_outside_wrapper'); //	HTML at bottom of page outside wrapper


	// Fonts
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_change_everything_font_size_rem', 'childishlysimple_options_sanitisation' );
	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_change_everything_font_family');

	register_setting( 'childishlysimple_register_this_layout', 'childishlysimple01_registered_layout_details' );	//	An array of all the saved option values including defaults and errors. DO NOT SANITISE! Individual options are left unsanitised where appropriate.	
} // end  function childishlysimple_set_up_my_layout
}







// Sanitise the options above
if ( !function_exists( 'childishlysimple_options_sanitisation' ) ) {
	function childishlysimple_options_sanitisation ($input) { 	
		$childishlysimple_options_allowed_html = array('strong' => array());
		$input = wp_kses($input, $childishlysimple_options_allowed_html);
		$input = esc_attr($input);
		return $input;
} // end  function childishlysimple_options_sanitisation
}
// Thanks to:	http://wp.tutsplus.com/tutorials/the-complete-guide-to-the-wordpress-settings-api-part-7-validation-sanitisation-and-input-i/







// !function_exists allows child theme to add extra options into the options page
if ( !function_exists( 'childishlysimple_function_to_create_layout' ) ) {
		function childishlysimple_function_to_create_layout( ) { 
									get_template_part ('admin/function-to-create-layout');								   
		}
}







/*
=Register dynamic sidebars (for widgets)  Embedded newlines look messy but work to format the output markup nicely. Couldn't get WP API n character to work
*/

add_action( 'widgets_init', 'childishlysimple_register_sidebars' ); 

if ( !function_exists( 'childishlysimple_register_sidebars' ) ) {
function childishlysimple_register_sidebars() {

register_sidebar( array( 'name' => 'Left Sidebar Widgets', 'id' => 'left_sidebar_widget_01',  'description' => 'Drag widgets here. They will appear in the left sidebar on your website. You can rearrange them by dragging them up or down.',  'before_widget' => '<div class="sidebar-item left-sidebar-item left-sidebar-widget left_sidebar_%2$s">',  'after_widget' => '

</div>




',   'before_title' => '
		<h2 class="widgettitle left-sidebar-item">', 'after_title' => '</h2>
		
		' ) );







register_sidebar( array( 'name' => 'Right Sidebar Widgets', 'id' => 'right_sidebar_widget_01',  'description' => 'Drag widgets here. They will appear in the right sidebar on your website. You can rearrange them by dragging them up or down.',  'before_widget' => '<div class="sidebar-item right-sidebar-item right-sidebar-widget right_sidebar_%2$s">',  'after_widget' => '

</div>




',   'before_title' => '
		<h2 class="widgettitle right-sidebar-item">', 'after_title' => '</h2>
		
		' ) );







register_sidebar( array( 'name' => 'Footer Widgets',  'id' => 'footer_widget_01',  'description' => 'Drag widgets here. They will appear in the footer in your website. You can rearrange them by dragging them up or down.', 'before_widget' => '<div class="outer-footer-item outer-footer-widget outer_footer_%2$s"> 
	<div class="inner-footer-item inner-footer-widget inner_footer_%2$s">
		', 'after_widget'  => '
		
		</div><!-- End inner-footer-item-->
</div><!--End outer-footer-item-->




', 'before_title' => '
		<h2 class="widgettitle footer-item">', 'after_title' => '</h2>
		
		' ) );





/*
// START DEPRECATED
register_sidebar( array( 'name' => 'Home Page (DEPRECATED)',  'id' =>  'very_simple_home_page_widget_01', 'description' => 'DEPRECATED. THIS WIDGET AREA WILL SOON BE REMOVED. PLEASE DRAG ANY WIDGETS FROM THIS AREA DOWN TO \'HOME PAGE BOTTOM WIDGETS\' BELOW', 'before_widget' => '	<div class ="outer-home-page-widget outer-home-page-widget-custom-post outer_home_page_%2$s">
		<div class="inner-home-page-widget inner-home-page-widget-custom-post inner_home_page_%2$s">
			', 'after_widget'  => '		
			
			</div><!-- end inner-home-page-widget -->
	</div><!-- end outer-home-page-widget -->




', 'before_title' => '
		<h2 class="widgettitle home-page-widget">', 'after_title' => '</h2>
		
		' ) );
// END DEPRECATED
*/





register_sidebar( array( 'name' => 'Home Page Bottom Widgets',  'id' =>  'bottom_home_page_widgets', 'description' => 'These widgets appear below your posts on the home page. Below these widgets you can also have footer widgets.', 'before_widget' => '


<div class ="outer-home-page-widget outer-home-page-bottom-widget  outer_home_page_bottom_%2$s">
	<div class="inner-home-page-widget inner-home-page-bottom-widget inner_home_page_bottom_%2$s">
			', 'after_widget'  => '		
			
	</div><!-- end inner-home-page-widget -->
</div><!-- end outer-home-page-widget -->






', 'before_title' => '
		<h2 class="widgettitle home-page">', 'after_title' => '</h2>
		
		' ) );






} //	End function childishlysimple_register_sidebars
}







/*
=Add stylesheets or javascript
*/

//	Add external stylesheet to all admin pages
if ( !function_exists( 'childishlysimple_add_to_admin_head' ) ) {
	function childishlysimple_add_to_admin_head(){
       		wp_register_style( 'style_admin_css', get_template_directory_uri() . '/style-admin.css', '', '', 'screen' );
        	wp_enqueue_style( 'style_admin_css' );
}
}

add_action('admin_enqueue_scripts', 'childishlysimple_add_to_admin_head');







// Add external stylesheets to website
// BUT NOT style.css as style.css needs to be before the internal stylesheet
// Here we're trying to make sure that the link to the external custom stylesheet is the very last thing output. That's irrelevant for the print stylesheet
// If file_exists is in case someone has a child theme that DOESN'T have these style sheets - otherwise there are error messages

if ( !function_exists( 'childishlysimple_add_stylesheets' ) ) {
	function childishlysimple_add_stylesheets() {	
	
		if ( file_exists( get_stylesheet_directory() . '/style-print.css' )) { // file_exists only works with paths
				wp_register_style( 'childishlysimple-style-print',  get_stylesheet_directory_uri() . '/style-print.css', '', '',  'print' );
		} else { 
				wp_register_style( 'childishlysimple-style-print',  get_template_directory_uri() . '/style-print.css', '', '',  'print' );
}


		if ( file_exists( get_stylesheet_directory() . '/style-custom.css' )) { // file_exists only works with paths
				wp_register_style( 'childishlysimple-style-custom',  get_stylesheet_directory_uri() . '/style-custom.css', '', '',  'screen' );
		} else { 
				wp_register_style( 'childishlysimple-style-custom',  get_template_directory_uri() . '/style-custom.css', '', '',  'screen' );
}

	
		wp_enqueue_style( 'dashicons' ); // http://jameskoster.co.uk/work/using-wordpress-3-8s-dashicons-theme-plugin/  http://melchoyce.github.io/dashicons/
		wp_enqueue_style( 'childishlysimple-style-print' );
		wp_enqueue_style( 'childishlysimple-style-custom', array ('dashicons') );
		//  wp_enqueue_style( 'childishlysimple-style', get_stylesheet_uri(), array('dashicons'), '3.0' );  

} // 	end function childishlysimple_add_stylesheets
}

add_action( 'wp_enqueue_scripts', 'childishlysimple_add_stylesheets', '999' );







/*
=Output shortcode, HTML etc. in head
*/

add_action( 'wp_head', 'function_to_output_options_in_head' );

if ( !function_exists( 'function_to_output_options_in_head' ) ) {
	function function_to_output_options_in_head () {

	$childishlysimple_backend_details = array();
	$childishlysimple_backend_details = get_option( 'childishlysimple01_registered_layout_details' ); 

if ( $childishlysimple_backend_details['major_errors'] == '' ) {
	echo "\n\n\n\n";
	echo do_shortcode( $childishlysimple_backend_details ['general_head_element'] ) . "\n\n";
	echo'<!-- Add CSS, HTML or javascript to the head element of all pages of your website -->' . "\n\n\n\n\n\n";
} else {
	echo do_shortcode( $childishlysimple_backend_details ['general_head_element_default'] ) . "\n\n";
	echo'<!-- Add CSS, HTML or javascript to the head element of all pages of your website -->' . "\n\n\n\n\n\n";
}







if ( is_front_page() ) { // CSS, shortcode etc. home page only
	if ( $childishlysimple_backend_details['major_errors'] == '' ) {
		echo do_shortcode( $childishlysimple_backend_details ['home_page_head_element'] ) . "\n\n";
		echo '<!-- Add CSS, HTML or javascript to the head element of the home page only -->' . "\n\n\n";
	} else {
		echo do_shortcode( $childishlysimple_backend_details ['home_page_head_element_default'] ) . "\n\n";
		echo '<!-- Add CSS, HTML or javascript to the head element of the home page only -->' . "\n\n\n\n\n";
	}
}







if( is_page_template( 'page-landing-page.php' ))  { 
	if ( $childishlysimple_backend_details['major_errors'] == '' ) {
		echo do_shortcode( $childishlysimple_backend_details ['landing_page_head_element'] ) . "\n\n";
		echo '<!-- Add CSS, HTML or javascript to the head element of a landing page -->' . "\n\n\n";
	} else {
		echo do_shortcode( $childishlysimple_backend_details ['landing_page_head_element_default'] ) . "\n\n";
		echo '<!-- Add CSS, HTML or javascript to the head element of a landing page -->' . "\n\n\n\n\n";
	}
}

} // End function_to_output_options_in_head()
}







/*
=Custom comments - the comment bubbles
*/

if ( !function_exists( 'childishlysimple_list_comments' ) ) {
function childishlysimple_list_comments( $comment, $args, $depth )  {	//	See comments.php
 $GLOBALS['comment'] = $comment; 
  

global $childishlysimple_count_comments;  
//	The variable $childishlysimple_count_comments can be used outside this function 

echo  "\n\n\n\n";
?>

<div <?php comment_class( ); ?> id="comment-<?php comment_ID( ) //	Add an ID to the div 	?>">
 		
	<div class="comment-body">

		<p class="comment-meta">

		<?php printf( __( '<span class="pre-comment-author">By</span><span class="comment-author"> %s</span> ' ), get_comment_author_link( ) ) ?>

			<span class="comment-date"><?php comment_date( 'D M jS Y' ) ?> at  <?php comment_date( 'g:i a' ) ?></span>
  
			<span class="comment-edit">
				<?php edit_comment_link(  '(Edit)' ,'  ','' ) //	Link to edit the comment ( if logged in )	?>  &nbsp;
			</span>

		</p>   <?php // End comment-meta ?>

	
	<div class="avatar">

		<?php echo get_avatar( $comment, 32 ) , "\n"; ?>
		
	</div><!-- end avatar-->
	

<?php if ( $comment->comment_approved == '0' ) : ?>

	<p class="moderation"><?php echo 'Your comment is awaiting moderation. Although you can see this comment no one else can.'  ?></p>
	<br />
	
<?php endif; //	If awaiting moderation 	?>


	<?php 
	echo  "\n";
	comment_text( ); //	The text of the comment 	
	echo  "\n\n\n";
	?>

	<p class="comment-reply-link">
	
	<?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'reply_text' => 'Reply to this person', 'login_text' => 'Log in to reply', 'max_depth' => $args['max_depth'] ) ) ) ?>
	
	</p>

</div><!--End comment-body-->

<?php 
} // end function childishlysimple_list_comments
}







/*
=Custom pings - the ping 'bubbles'
*/

//  Uses the same HTML as the comments except for the ping count.
//  With thanks to   http://sivel.net/2008/10/wp-27-comment-separation/   

if ( !function_exists( 'childishlysimple_list_pings' ) ) {
	function childishlysimple_list_pings( $comment, $args, $depth ) { //	See comments.php
       $GLOBALS['comment'] = $comment;

	global $childishlysimple_ping_count; 
	echo  "\n\n\n";
?>

<div class="comment depth-1">

	<div class="comment-body ping-body">
	
		<p class="comment-meta">

<?php printf( __( '<span class="pre-comment-author">By</span><span class="comment-author"> %s</span> ' ), get_comment_author_link( ) )   ?>

			<span class="comment-date"><?php comment_date( 'D M jS Y' ) ?> at  <?php comment_date( 'g:i a' ) ?></span>

				<span class="comment-edit">
				<?php edit_comment_link(  '(Edit)' ,'  ','' ) //	Link to edit the comment ( if logged in )?>&nbsp;
				</span>


			</p>   <?php //	End comment-meta   ?>

			<div class="ping-text">
			<?php 
			echo  "\n\n\n";
			comment_text( );  //	The ping text  
			echo  "\n\n\n";
			?>
			
			&nbsp;</div><!-- End ping-text -->

		</div><!--End comment-body-->

<?php 
} // end function childishlysimple_list_pings.   The last div is added automatically by WP
}







/*
=Error notice - admin
*/

$childishlysimple_test_for_errors = array ();
$childishlysimple_test_for_errors = get_option( 'childishlysimple01_registered_layout_details' ); 

$childishlysimple_test_for_errors_result = '';
$childishlysimple_test_for_major_errors_result = '';

if ( ! empty ( $childishlysimple_test_for_errors['errors'] ) ) $childishlysimple_test_for_errors_result = $childishlysimple_test_for_errors['errors'];
if ( ! empty ( $childishlysimple_test_for_errors['major_errors'] ) ) $childishlysimple_test_for_major_errors_result = $childishlysimple_test_for_errors['major_errors'];


if ( !function_exists( 'childishly_simple_error_notice' ) ) {
	function childishly_simple_error_notice(){
    		echo '<div class="error">
       		<p class="minor-error">There are minor errors on the Childishly Simple Options page - search for error messages highlighted in red (somewhere above a big red rectangle) on that page. Defaults will be set.</p>
    		</div>';
}
}

if( $childishlysimple_test_for_errors_result == 'errors' ) add_action('admin_notices', 'childishly_simple_error_notice');







if ( !function_exists( 'childishly_simple_major_error_notice' ) ) {
	function childishly_simple_major_error_notice(){
    		echo '<div class="error">
       		<p style="font-weight:bold;">There are major errors on the Childishly Simple Options page (Appearance / Childishly Simple Options) - search for the error messages highlighted in red on that page. YOUR SITE WILL REVERT TO DEFAULTS UNTIL THIS IS SORTED OUT.</p>
    		</div>';
} // end function childishly_simple_major_error_notice
}

if( $childishlysimple_test_for_major_errors_result == 'major_errors' ) add_action('admin_notices', 'childishly_simple_major_error_notice');







if(is_admin() && isset($_GET['activated']) && $pagenow = 'themes.php') { 
		header('Location: '.admin_url().'themes.php?page=childishlysimple_options');
}			// Redirect to options page on activation. Thanks to Suffusion theme  http://wordpress.org/extend/themes/suffusion	




?>